#ifndef ASM_AGB_H
#define ASM_AGB_H
#ifndef __ASSEMBLY__
#define __ASSEMBLY__
#endif

#define ARM_IWRAM_ENTRY(LABEL)	\
	.arm;.section .iwram; .align 2; .global LABEL; .type LABEL, %function; LABEL:
#define ARM_ENTRY(LABEL)	\
	.arm; .text; .align 2; .global LABEL; .type LABEL, %function; LABEL:
#define THUMB_EWRAM_ENTRY(LABEL)	\
	.thumb;.section .ewram; .align 2; .global LABEL; .type LABEL, %function; LABEL:
#define THUMB_ENTRY(LABEL)	\
	.thumb; .text; .align 2; .global LABEL; .type LABEL, %function; LABEL:
#define DATA_ENTRY(LABEL)	\
	.data; .align 2; .global LABEL; LABEL:
#define LOCAL_ENTRY(LABEL)	\
	.data; .align 2; LABEL:

#define PSR_MODE_MASK	0x001f
#define PSR_MODE_USR	0x0010
#define PSR_MODE_FIQ	0x0011
#define PSR_MODE_IRQ	0x0012
#define PSR_MODE_SVC	0x0013
#define PSR_MODE_ABT	0x0017
#define PSR_MODE_UND	0x001b
#define PSR_MODE_SYS	0x001f

#define PSR_THUMB		0x0020
#define PSR_ARM			0x0000

#define PSR_INT_MASK	0x00c0
#define PSR_DISABLE_FIQ	0x0040
#define PSR_DISABLE_IRQ	0x0080

#endif
