#include <stdlib.h>
#include <string.h>
#include "coroutine.h"

#define CO_STACK_SIZE_ (CO_STACK_SIZE / sizeof(unsigned int))

//----------------------------------------------------------------------
struct _regs {
	unsigned int r4, r5, r6, r7, r8, r9, r10, r11, r12, lr;
};

typedef struct {
	void (*proc)(void *);
	void *data;
	void *sp;
	unsigned int stack[CO_STACK_SIZE_];
} coroutine_t_impl ;

//----------------------------------------------------------------------
coroutine_t 
co_create(void (*proc)(void*), void *data)
{
	coroutine_t_impl *c = malloc(sizeof(coroutine_t_impl));
	memset(c, 0xff, sizeof(coroutine_t_impl));
	c->proc = proc;
	c->data = data;
	c->sp = &c->stack[CO_STACK_SIZE_];

	c->sp -= sizeof(struct _regs);

	struct _regs *r = c->sp;
	r->lr = ((unsigned int)proc & 1) ?
		(unsigned int)co_exit_thumb : (unsigned int)co_exit;
	return c;
}

//----------------------------------------------------------------------
void 
co_delete(coroutine_t co)
{
	free(co);
}

//----------------------------------------------------------------------
void *
co_get_data(coroutine_t co)
{
	return ((coroutine_t_impl *)co)->data;
}
